//findstr  ver.0.00  2007.4.25
// copyright Beer

#include	<Be.h>

#define	USAGE	"usage : findstr [-v] [-src] str path ...\n"\
						"\t-v   ... verbose\n"\
						"\t-src ... source(.h .c .cpp) only"

void	searchfile(BEntry *ent);
void	findstr(const char *fname,char *buf,int size);
void	quit(char *p);

char	*search_str=NULL;
int		search_len=0;
bool	srcf=false;		//.h .c .cpp only
bool	vbf=false;		//verbose

int main(int argc,char **argv)
{
	int	opc=0;
	for(int i=1;i<argc;i++)if(argv[i][0]=='-'){
		opc++;
		if(!strcmp(argv[i],"-src"))srcf=true;
		if(!strcmp(argv[i],"-v"))vbf=true;
	}
	if(argc-opc<3)quit(USAGE);
	search_str=argv[opc+1];
	search_len=strlen(search_str);

	for(int i=opc+2;i<argc;i++){
		BEntry	ent(argv[i]);
		if(ent.InitCheck())quit("cannot find file or directory");
		searchfile(&ent);
	}
}

void searchfile(BEntry *ent)
{
	struct stat	st;
	ent->GetStat(&st);
	if(S_ISREG(st.st_mode)){	//file
		if(srcf){
			bool	f=false;
			char	s[256];
			ent->GetName(s);
			int		sl=strlen(s);
			if((sl>1)&&(!strcmp(s+sl-2,".h")))f=true;
			if((sl>1)&&(!strcmp(s+sl-2,".c")))f=true;
			if((sl>3)&&(!strcmp(s+sl-4,".cpp")))f=true;
			if(!f)return;
		}
		BPath	p;
		ent->GetPath(&p);
		if(vbf)printf("%s\n",p.Path());
		int		size=st.st_size;
		char	*buf=new char[size+1];
		BFile	f(ent,B_READ_ONLY);
		f.Read(buf,size);
		buf[size]=0;
		findstr(p.Path(),buf,size);
		delete buf;
	}else if(S_ISDIR(st.st_mode)){	//dir
		BDirectory	dir(ent);
		while(1){
			BEntry	e;
			if(dir.GetNextEntry(&e))break;
			searchfile(&e);
		}
	}else if(S_ISLNK(st.st_mode)){	//link
	}else{							//unknown
	}
}

void findstr(const char *fname,char *buf,int size)
{
	bool	f=!vbf;
	int	off=0;
	for(int lno=1;off<size;lno++){
		int	len=0;
		while(buf[off+len]){
			if(buf[off+len]==0x0a)break;
			len++;
		}
		char	*p=new char[len+1];
		strncpy(p,buf+off,len);
		p[len]=0;
		if((len>=search_len)&&(strstr(p,search_str))){
			if(f){printf("%s\n",fname);f=false;}
			printf("  line %d : %s\n",lno,p);
		}
		delete p;
		off+=len+1;
	}
}

void quit(char *p)
{
	if(*p){
		printf("%s\n",p);
		exit(1);
	}else{
		exit(0);
	}
}
